Subject: Re: " [AVT] RE: RTP/RTCP Port Sharing (Was: Comedia Issues.) "

From: Orion Hodson <[email-masked]>
Date: Mon, 16 Jul 2001 23:16:40 -0700

Jonathan Rosenberg writes:
> > Am I the only person here who's baffled that this idea 
> > (allowing RTP and 
> > RTCP to use the same port) is being taken seriously at all?  
> > Not only would 
> > this would break most - if not all - existing RTP/RTCP 
> > implementations, but 
> > multiplexing control and data information at this level is generally 
> > considered bad design.
> 
> I agree with you in theory, Ross. The problem is that NATs are considered an
> even worse design choice. However, they exist, and we need to deal with
> them. 
> 
> The specific problem I'm running into is the lifetime of NAT bindings. Right
> now, RTP and RTCP will both require a separate binding. NAT bindings are
> kept alive by activity. Unfortunately, if silence suppression is used, the
> RTP nat binding will timeout, and the media is not recovered. The
> periodicity of RTCP keeps its bindings active. I'd like to be able to use
> that information to keep the RTP binding fresh as well. That happens if they
> are both on the same port.

Did the alternative of allowing unicast RTP apps to send some data to
maintain the binding get considered/rejected?  Refresh data could be
valid RTP data, like comfort-noise and repeat video-cells, or invalid
and destined to be rejected by the receiver, e.g. duplicate
seqno/timestamp, invalidly framed rtp payload, unsupported codec.
Only one application in a session would need to be modified to support
this and it's almost certainly less work to implement.

- Orion